/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc           = gc || {};
gc.services      = gc.services || {};
var notifCount   = 0;
var notifsLeft   = 0;
var currentNotif = 0
var jsonObj = { "category":"No Data",
                "appID":"No Data",
                "appDS":"No Data",
                "title":"No Data", 
                "message":"No Data",
                "date":"No Data",
                "dropListLabels":"Populating", 
                "dropListIndex":"1",
                "totalNotifs":"0",
                "currentNotif":"0",
                "discProgress":"0",
                "appState":"No Data",
                "currentImg":"0"
}; 
var saved;
var maxNotifs = 0;
var notifData = [];
for(i = 0; i < 200 ; i++){
    notifData[i] = [];
    for(j=0;j<6;j++){
      notifData[i][j] = "No Data" ;
    }
}

/*
 *  Boilerplate code for encoding and decoding data transmitted to / received from TI devices.
 */



/**
 * This code implements the IPacketCodec interface.
 *
 * @constructor
 * @implements gc.databind.IPacketCodec
 */
CustomCodec = function()
{
};
CustomCodec.prototype.rxPktCtr = 0;
CustomCodec.prototype.rxMsgCtr = 0;
CustomCodec.prototype.txPktCtr = 0;
CustomCodec.prototype.txMsgCtr = 0;
CustomCodec.prototype.strRxBuffer = "";
CustomCodec.prototype.strTxBuffer = "";
CustomCodec.prototype.isConnect = false;
CustomCodec.prototype.initComplete = false;

/**
 * Encodes data into a packet for sending to the target device.
 *
 * @param target - function to call to pass on the encoded data towards the target
 * @param data - The data object from the GUI that is to be encoded into a packet for sending.
 */
CustomCodec.prototype.encode = function(target,jsonObj){
    this.txPktCtr++;

    /* The following example code shows how to decode JSON strings going down to the target
       into a Javascript object.  You would use this if you wanted to intercept data from the GUI
       and rework it before passing it on to the target device.
    */
        try {
            this.txMsgCtr++;
            if (this.txMsgCtr % 256){
                console.log("Number of tx messages to target: "+this.txMsgCtr);
            }
            // send the string to the target
            
            jsonObj.currentNotif = (parseInt(jsonObj.dropListIndex));
            jsonObj.category     = notifData[parseInt(jsonObj.dropListIndex)-1][0];
            jsonObj.appID        = notifData[parseInt(jsonObj.dropListIndex)-1][1];
            jsonObj.appDS        = notifData[parseInt(jsonObj.dropListIndex)-1][2];
            jsonObj.title        = notifData[parseInt(jsonObj.dropListIndex)-1][3];
            jsonObj.message      = notifData[parseInt(jsonObj.dropListIndex)-1][4];
            jsonObj.date         = notifData[parseInt(jsonObj.dropListIndex)-1][5];
            if(jsonObj.appID == "com.apple.mobilephone"){
                jsonObj.currentImg = 1;
            }else if(jsonObj.appID == "com.apple.MobileSMS"){
                jsonObj.currentImg = 2;
            }else if(jsonObj.appID == "com.apple.mobilemail"){
                jsonObj.currentImg = 3;
            }else if(jsonObj.appID == "com.toyopagroup.picaboo"){
                jsonObj.currentImg = 4;
            }else if(jsonObj.appID == "com.tinyspeck.chatlyio"){
                jsonObj.currentImg = 5;
            }else if(jsonObj.appID == "com.burbn.instagram"){
                jsonObj.currentImg = 6;
            }else if(jsonObj.appID == "com.apple.podcasts"){
                jsonObj.currentImg = 7;
            }else if(jsonObj.appID == "com.google.Gmail"){
                jsonObj.currentImg = 8;
            }else if(jsonObj.appID == "com.google.ios.youtube"){
                jsonObj.currentImg = 9;
            }else if(jsonObj.appID == "com.google.Maps"){
                jsonObj.currentImg = 10;
            }else if(jsonObj.appID == "net.whatsapp.WhatsApp"){
                jsonObj.currentImg = 11;
            }else{
                jsonObj.currentImg = 0;
            }
            saved(jsonObj);
        }
        catch(ex){
            console.log("CustomCodec.encode (to target): exception="+ex);
        }
    
    
};
/**
 * Decodes packets from the target device into data objects.  One object for each packet of data.
 * Unless you have chained your custom codec with the CR codec, the packet data is not framed,
 * so this method is responsible for decoding partial packets as well as multiple packets.  Partial packets
 * should not be returned, but deferred until the next decode method call with more raw data to process.  As a
 * result, this method may return 0 or more packets of data on each invocation.
 *
 * @param target -  function to call to pass on the encoded data towards the GUI
 * @param data  - The raw data received that needs to be decoded from packets into objects.
 * @return - true if connected (i.e. valid data received), false if not connected
 */
CustomCodec.prototype.decode = function(target, data) {
    this.isConnected = true;
    this.rxPktCtr++;

    /* The following example code shows how to decode JSON strings coming up from the target
       into a Javascript object.  You would use this if you wanted to intercept data from the target
       and rework it before passing it on to the GUI for binding
    */
    var strRxData = data.map(function(value) { return String.fromCharCode(value);} ).join("");
    this.strRxBuffer = this.strRxBuffer+strRxData;
    var strMessage = '';
    while (this.strRxBuffer.indexOf('\n') !== -1) {
        strMessage = this.strRxBuffer.substring(0, this.strRxBuffer.indexOf('\n') + 1);
        this.strRxBuffer = this.strRxBuffer.substring(strMessage.length);
        // Rework the following code if your codec is not receiving Javascript objects from the GUI
        try {
            if(!notifData)
                notifData = [];
            if(!notifData[currentNotif-1])
                notifData[currentNotif-1] = [];
            if(strMessage.substring(0,11) == "* Category:"){
                currentNotif++;
                jsonObj.category = strMessage.substring(12);
                notifData[currentNotif-1][0] = jsonObj.category;
            }else if(strMessage.substring(0,8) == "* appID:"){
                jsonObj.appID = strMessage.substring(9,strMessage.length-2);
                notifData[currentNotif-1][1] = jsonObj.appID;

                if(jsonObj.appID == "com.apple.mobilephone"){
                    jsonObj.currentImg = 1;
                }else if(jsonObj.appID == "com.apple.MobileSMS"){
                    jsonObj.currentImg = 2;
                }else if(jsonObj.appID == "com.apple.mobilemail"){
                    jsonObj.currentImg = 3;
                }else if(jsonObj.appID == "com.toyopagroup.picaboo"){
                    jsonObj.currentImg = 4;
                }else if(jsonObj.appID == "com.tinyspeck.chatlyio"){
                    jsonObj.currentImg = 5;
                }else if(jsonObj.appID == "com.burbn.instagram"){
                    jsonObj.currentImg = 6;
                }else if(jsonObj.appID == "com.apple.podcasts"){
                    jsonObj.currentImg = 7;
                }else if(jsonObj.appID == "com.google.Gmail"){
                    jsonObj.currentImg = 8;
                }else if(jsonObj.appID == "com.google.ios.youtube"){
                    jsonObj.currentImg = 9;
                }else if(jsonObj.appID == "com.google.Maps"){
                    jsonObj.currentImg = 10;
                }else if(jsonObj.appID == "net.whatsapp.WhatsApp"){
                    jsonObj.currentImg = 11;
                }else{
                    jsonObj.currentImg = 0;
                }
            }else if(strMessage.substring(0,11) == "* App Name:"){
                jsonObj.appDS = strMessage.substring(12);
                notifData[currentNotif-1][2] = jsonObj.appDS;
            }else if(strMessage.substring(0,8) == "* Title:"){
                jsonObj.title = strMessage.substring(9);
                notifData[currentNotif-1][3] = jsonObj.title;
                
                if(jsonObj.dropListLabels == "No notifications" || jsonObj.dropListLabels == "Populating"){
                    jsonObj.dropListLabels = ("Notification: "+currentNotif+" -"+jsonObj.title);
                }else{
                    jsonObj.dropListLabels += ("|Notification: "+currentNotif+" -"+jsonObj.title);
                }
            }else if(strMessage.substring(0,10) == "* Message:"){
                jsonObj.message = strMessage.substring(11);
                notifData[currentNotif-1][4] = jsonObj.message;
            }else if(strMessage.substring(0,7) == "* Date:"){
                jsonObj.date = strMessage.substring(8);
                notifData[currentNotif-1][5] = jsonObj.date;
            }else if(strMessage.substring(0,16) == "New Notification"){
                notifCount++;
                jsonObj.totalNotifs = notifCount;

            }else if(strMessage.substring(0,20) == "Total Notifications:"){
                notifsLeft = parseInt(strMessage.substring(20, strMessage.length-1));
                jsonObj.currentNotif = currentNotif;
                if(currentNotif != notifCount){
                    templateObj.$.ti_widget_droplist.disabled = true;
                }else{
                    templateObj.$.ti_widget_droplist.disabled = false;
                }
            }else if(strMessage.substring(0,19) == "Discovery Progress:"){
                jsonObj.discProgress = strMessage.substring(20,strMessage.length-1);
            }else if(strMessage.substring(0,16) == "Discovery State:"){
                if( (strMessage.substring(17,29) == "Disconnected") || (strMessage.substring(17,26) == "Timed out") ){
                    jsonObj.appID          = "No Data";
                    jsonObj.appNS          = "No Data";
                    jsonObj.title          = "No Data";
                    jsonObj.message        = "No Data";
                    jsonObj.date           = "No Data";
                    jsonObj.category       = "No Data";
                    jsonObj.currentImg     = 0;
                    jsonObj.totalNotifs    = "0";
                    jsonObj.currentNotif   = "0";
                    jsonObj.dropListLabels = "No notifications";
                    notifCount             = 0;
                    currentNotif           = 0;
                    templateObj.$.ti_widget_progressbar.visible  = false;
                    templateObj.$.ti_widget_label.visible        = false;
                    templateObj.$.ti_widget_label1.visible       = true;
                    templateObj.$.ti_widget_progressbar1.visible = true;
                }else if(strMessage.substring(17,26) == "Connected"){
                    templateObj.$.ti_widget_progressbar1.visible = false;
                    templateObj.$.ti_widget_label1.visible       = false;
                    templateObj.$.ti_widget_label.visible        = true;
                    templateObj.$.ti_widget_progressbar.visible  = true;
                    
                } 
                
                jsonObj.appState = strMessage.substring(17);
            }
            
            // send the received and decoded javascript object to the application where you can use it to bind to widget properties
            saved = target;
            target(jsonObj);
            
        }
        catch(ex){
            console.log("CustomCodec.decode (from target): strMessage="+strMessage+", exception="+ex);
        }
    }
    

    // Return true to set the 'Hardware Connected' status in the status bar
    return this.isConnected;

};



    
var close = function(){
    gc.databind.unregisterCustomCodec("custom",CustomCodec);
    CustomCodec.initComplete = false;
    CustomCodec.isConnected = false;
};

// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    templateObj = document.querySelector('#template_obj');
    // You can 'chain' codecs together to make it easier to work with the data
    // coming from the device or going to the device.
    // The following codecs are provided:
    //   CR  - use this if the target data uses /n as a delimiter for framing.
    //         The CR codec will take care of buffering the incoming data so that
    //         your codec will only receive complete 'ready to use' packets
    //  If your target uses /n delimited strings, set baseCodecs = "CR"
    //  If your target uses some other format for data (e.g. binary data or custom strings) leave baseCodecs = "undefined"

    var baseCodecs = undefined;
    console.log("custom codec: about to register..."); // log a message that you will be able to see in the debugger
    gc.databind.registerCustomCodec("custom",CustomCodec, baseCodecs);

    CustomCodec.initComplete = true;
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded',init.bind(this))
}
